#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"


int 
main(int argc, char **argv)
{
  int j, p;


  /* Start up MPI */

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &j);
  MPI_Comm_size(MPI_COMM_WORLD, &p);
 


  int r = 10;
  MPI_Win win;
  MPI_Aint sizeOfInt;

  MPI_Type_extent(MPI_INT,&sizeOfInt);

  //MPI_Win_create(&r,sizeOfInt,1,MPI_INFO_NULL,MPI_COMM_WORLD,&win);
  MPI_Win_create(&r,sizeOfInt,1,MPI_INFO_NULL,MPI_COMM_WORLD,&win);

  printf("%d: win created. will put to %d\n",j,(j+1)%p);

  MPI_Win_fence(0,win); 

  //if (j == 0) MPI_Put(&j,1,MPI_INT,1,0,1,MPI_INT,win);
  //if (j == 1) MPI_Put(&j,1,MPI_INT,0,0,1,MPI_INT,win);

  MPI_Put(&j,1,MPI_INT,(j+1)%p,0,1,MPI_INT,win);
  //MPI_Finalize();
  //return 0;
  
  MPI_Win_fence(0,win); 

  printf("%d: last is %d\n",j,r);

  MPI_Win_free(&win);

  MPI_Finalize();
  return 0;
}
